
' Sinusoszillator
'
' Erzeugung per PWM- Oszillator; sein Puls- Pausenverhltnis wird mit den 64 Werten einer approximierten
' Sinusfunktion geladen.

' Da die PWM- Taktfrequenz ber 18 kHz betragen muss, damit man sie nicht hrt, muss der AtTiny 13 mit 9,6 MHz
' Takt betrieben werden.

' Der Attiny 13 kann jedoch auf 1,2 MHz geflasht bleiben (Auslieferungszustand), die Taktumschaltung auf 9,6
' MHz erfolgt ber das CLKPR- Register zur Laufzeit des Programms

' Der Sinus liegt an OC0A, also PB0

'----------------------------------------------------------

$regfile = "attiny13.dat"
$crystal = 9600000

$hwstack = 32
$swstack = 8
$framesize = 8


'Variablen

Dim I As Byte                                               '
Dim N As Byte                                               '
Dim M As Byte                                               '

Clkpr = 128
Clkpr = 0                                                   ' Taktumschaltung 9,6 MHz
Clkpr = 0


Acsr.7 = 1                                                  ' Analog-Komparator ausschalten, spart etwas Strom

Ddrb = &B0000_0001                                          ' alle Pins bis auf PB0 Eingang
Portb = &B0001_1110                                         ' alle Pins bis auf PB0 Pullup-Widerstand


'----------------------------------------------------------


Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down
Start Timer0
Tccr0a.0 = 1                                                'wgm00
Tccr0a.1 = 1                                                'wgm01
Tccr0b.3 = 0                                                'wgm02


Do

      Restore Sinusdata                                     ' Zeiger auf Anfang der Tabelle setzen

      For N = 1 To 64
         Read M
         Pwm0a = M                                          ' der Wert in PWM0A bestimmt das Puls- / Pausenverhltnis
         Waitus 20                                          ' Verzgerungszeit setzt die Frequenz des Sinus herab
      Next M

Loop



Sinusdata:

Data 0 , 0 , 2 , 5 , 9 , 14 , 21 , 28 , 36 , 46 , 56 , 66 , 78 , 89 , 101 , 114,
Data 127 , 139 , 151 , 163 , 175 , 186 , 197 , 207 , 216 , 225 , 232 , 238 , 244 , 248 , 251 , 253,
Data 253 , 253 , 251 , 248 , 244 , 239 , 232 , 225 , 216 , 207 , 197 , 187 , 175 , 164 , 151 , 139,
Data 127 , 114 , 102 , 90 , 78 , 67 , 56 , 46 , 37 , 28 , 21 , 15 , 9 , 5 , 2 , 0,