
' Sinusoszillator
'
' Erzeugung per PWM- Oszillator; sein Puls- Pausenverhltnis wird mit den 128 Werten einer approximierten
' Sinusfunktion geladen.

' Da die PWM- Taktfrequenz ber 18 kHz betragen muss, damit man sie nicht hrt, muss der AtTiny 13 mit 9,6 MHz
' Takt betrieben werden.

' Der Attiny 13 kann jedoch auf 1,2 MHz geflasht bleiben (Auslieferungszustand), die Taktumschaltung auf 9,6
' MHz erfolgt ber das CLKPR- Register zur Laufzeit des Programms.

' Der Sinus liegt an OC0A, also PB0

' der Generator wird mit einem Taster an PB3 (gegen Masse getastet) aktiviert.
' ber Zeitschleifen und die Variable "L" wird Kontaktprellen unterdrckt.
'
'----------------------------------------------------------

$regfile = "attiny13.dat"
$crystal = 9600000


$hwstack = 32
$swstack = 8
$framesize = 8


'Variablen

Dim L As Byte
Dim N As Byte
Dim M As Byte


Clkpr = 128
Clkpr = 0
Clkpr = 0

Acsr.7 = 1                                                  ' Analog-Komparator ausschalten, spart etwas Strom

Ddrb = &B0000_0001                                          ' alle Pins Eingang ausser PB0
Portb = &B0001_1110                                         ' alle Pins ausser PB0 Pullup-Widerstand

'----------------------------------------------------------



Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down
Start Timer0
Tccr0a.0 = 1                                                'wgm00
Tccr0a.1 = 1                                                'wgm01
Tccr0b.3 = 0                                                'wgm02



L = 0

Do



   If Pinb.3 = 0 Then                                       ' Abfrage, ob Taster an PB3 gedrckt

     Do

       Restore Sinusdata                                    ' Zeiger auf Anfang der Tabelle setzen
       For N = 1 To 128
          Read M
          Pwm0a = M                                         ' der Wert in PWM0A bestimmt das Puls- / Pausenverhltnis
          Waitus 6                                          ' Verzgerungszeit setzt die Frequenz des Sinus herab
       Next M
       Incr L
     Loop Until L > 8                                       ' Schleife gegen Kontaktprellen

   Else
     Waitms 15                                              ' Wartezeit gegen Kontaktprellen
     L = 0

   End If


Loop



Sinusdata:

Data 0 , 0 , 0 , 1 , 2 , 3 , 5 , 7 , 9 , 12 , 14 , 17 , 21 , 24 , 28 , 32,
Data 36 , 41 , 46 , 51 , 56 , 61 , 66 , 72 , 78 , 83 , 89 , 95 , 101 , 107 , 114 , 120,
Data 127 , 133 , 139 , 145 , 151 , 157 , 163 , 169 , 175 , 181 , 186 , 192 , 197 , 202 , 207 , 212,
Data 216 , 221 , 225 , 228 , 232 , 235 , 238 , 241 , 244 , 246 , 248 , 250 , 251 , 252 , 253 , 253,
Data 253 , 253 , 253 , 252 , 251 , 250 , 248 , 246 , 244 , 241 , 239 , 236 , 232 , 229 , 225 , 221,
Data 216 , 212 , 207 , 202 , 197 , 192 , 187 , 181 , 175 , 169 , 164 , 158 , 151 , 145 , 139 , 133,
Data 127 , 120 , 114 , 108 , 102 , 96 , 90 , 84 , 78 , 72 , 67 , 61 , 56 , 51 , 46 , 41,
Data 37 , 33 , 28 , 25 , 21 , 18 , 15 , 12 , 9 , 7 , 5 , 3 , 2 , 1 , 0 , 0,